import hashlib
import hmac
import datetime
import time
import os


class bypass_token:
	def __init__(self,token_file_path,get_random):
		self.token_file_path = token_file_path
		self.get_random = get_random
		# def get_random(self,nbytes,extrapool = None):

	def open_create_write_file(self):
		if os.path.isfile(self.token_file_path) == False:
			fh = open(self.token_file_path,'w')
			fh.write("# in/out,keyid,tokenhash,create_time,expire_time\n")
		else:
			fh = open(self.token_file_path,'a')
		return fh

	def get_outgoing_token(self,keyid,earliest_date):
		keyid_in = keyid.lower()
		result = None
	 	is_new = False
		now_time = datetime.datetime.now().strftime("%Y-%m-%dT%H:%M:%SZ")
		if os.path.isfile(self.token_file_path):
			fh = open(self.token_file_path,'r')
			for line in fh:
				line = line.rstrip('\r\n')
				inout,keyid,token_hash,create_time,expire_time = line.split(',')
				if inout == 'out' and keyid_in == keyid and \
				create_time >= earliest_date and \
				( expire_time == 'never' or expire_time > now_time ):
					result = token_hash + ',' + create_time + ',' + expire_time
			fh.close()
		if result == None:
			token_hash = self.get_random(20,keyid_in).encode('hex').lower()
			result = token_hash + ',' + now_time + ',never'
			fh = self.open_create_write_file()
			fh.write('out,' + keyid_in + ',' + result + "\n")
			fh.close()
			is_new = True
		return is_new,result

	def add_incoming_or_replicated_token(self,keyid,token,create_time,expire_time,inout_in = 'in'):
		keyid_in = keyid.lower()
		token_in = token.lower()
		match = False
		if os.path.isfile(self.token_file_path):
			fh = open(self.token_file_path,'r')
			for line in fh:
				line = line.rstrip('\r\n')
				inout,keyid,token_hash,create_time,expire_time = line.split(',')
				if inout == inout_in and keyid_in == keyid and token_in == token:
					match = True
			fh.close()
		if match == False:
			fh = self.open_create_write_file()
			fh.write(inout_in + ',' + keyid_in + ',' + token_in + ',' + create_time + ',' + expire_time + "\n")
			fh.close()

	def get_earliest_time(self):
		earliest_time = None
		if os.path.isfile(self.token_file_path) == True:
			fh = open(self.token_file_path,'r')
			for line in fh:
				line = line.rstrip('\r\n')
				inout,keyid,token_hash,create_time,expire_time = line.split(',')
				if inout == 'out' and \
				( earliest_time == None or earliest_time > create_time):
					earliest_time = create_time
			fh.close()
		if earliest_time == None:
			earliest_time = datetime.datetime.now().strftime("%Y-%m-%dT%H:%M:%SZ")
		return earliest_time

	def generate_bypass_hash(self,keyid,hashdata):
		keyid_in = keyid.lower()
		if os.path.isfile(self.token_file_path) == False:
			return None
		now_time = datetime.datetime.now().strftime("%Y-%m-%dT%H:%M:%SZ")
		chosen_hash = None
		chosen_time = None
		fh = open(self.token_file_path,'r')
		for line in fh:
			line = line.rstrip('\r\n')
			inout,keyid,token_hash,create_time,expire_time = line.split(',')
			if inout == 'in' and keyid_in == keyid and \
			create_time <= now_time and \
			( expire_time == 'never' or expire_time > now_time ) and \
			( chosen_time == None or chosen_time < create_time):
				chosen_time = create_time
				chosen_hash = token_hash		
		fh.close()
		if chosen_hash == None:
			return None
		else:
			return hmac.new(chosen_hash.decode('hex'),hashdata,hashlib.sha1).hexdigest().lower()

	def verify_bypass_hash(self,hashval,hashdata):
		if os.path.isfile(self.token_file_path) == False:
			return None
		hashval = hashval.lower()
		fh = open(self.token_file_path,'r')
		match = None
		now_time = datetime.datetime.now().strftime("%Y-%m-%dT%H:%M:%SZ")
		for line in fh:
			line = line.rstrip('\r\n')
			inout,keyid,token_hash,create_time,expire_time = line.split(',')
			if inout == 'out' and create_time <= now_time and \
			( expire_time == 'never' or expire_time > now_time ):
				testhash = hmac.new(token_hash.decode('hex'),hashdata,hashlib.sha1).hexdigest().lower()
				if testhash == hashval:
					match = keyid
		fh.close()
		return match

# random_pool_size = 1024
# class random:
# 	def __init__(self):
# 		self.random_pool = self.get_random_pool().decode('hex')
# 
# 	def get_random(self,nbytes,extrapool = None):
# 		rand_hasher = hashlib.new('sha256')
# 		rand_hasher.update(self.random_pool)
# 		rand_hasher.update(str(time.time()))
# 		rand_hasher.update(str(nbytes))
# 		if extrapool != None:
# 			rand_hasher.update(extrapool)
# 		self.random_pool = rand_hasher.digest() + self.random_pool[0:random_pool_size]
# 		return self.random_pool[0:nbytes]
# 
# 	def get_random_pool(self):
# 		return \
# 		"a9da033c532fddafede12d27d0607682360e490f33fe04bfade192f879619dd3" + \
# 		"a3664d5f1409e368f44f6e8f6843299e6488e4aa08e9fc13d6fbdbc092a97f2b" + \
# 		"b0d4b787770e67ee34263c118b800c61e71934efbb27583c8cf436b626abecb0" + \
# 		"833684b1551d9e0779349b59231b25dcd880403a182b841fbb57f87c5673cefc" + \
# 		"f47da26dffd48746ae18e79e55b1c8fb1c170095e6becd12c06b2e749accd6a9" + \
# 		"ba7d6ad425ee72ae6fbc1a2d5c1a475abf60a06be479d40101c38961932b730b" + \
# 		"6fe3c1a0c801dd08843b3d71dbef5c404189d9673db879e4141c7b5cb97b3265" + \
# 		"a341f07b2f68dea7ed1efc2454a42e23cf22a5672e07018b9f3ec72e3067da94" + \
# 		"d423af54bb78368a2ae86616ecaaf13f5534a1f28d7a0f3828a7e7ee13d7265f" + \
# 		"cf7a8361364982dc32d9252001e4c503f814cb1a001f5e0e7830469cf8c917cc" + \
# 		"44d383741a410d3e6efbe705aaea50f733ac6e3471f9c3d973cae0245c11ecf2" + \
# 		"e904ef036a5daa8d85cd0900719920f8fbc670ed8e3e1b20c8f007c724d74f85" + \
# 		"27c209480ce752beaf0103882f5f94aaded49bdfadc72308b96093644d7b193a" + \
# 		"18acdb3e7676c6854ea8fdf33482d0122bf6a56bc877175e5770a88918404071" + \
# 		"11213355bbff102564e12d19c530f7891fde7c9e8c9c447e26c7897fc9f82cea" + \
# 		"f73c11a287f17d4c7f412ee655c2d33b4d6c9090ef0c1a04c9d92e4486d594a9" + \
# 		"9c611e8b0e7fa9b7c532adb181488e50fc0ac59644593b3c013c024d4e61d326" + \
# 		"b7041b63b8ae862aaf9cfd9e0470deb77d1a07f94718875d5e68ab694795a0a8" + \
# 		"60406f5791da2c6cfb94ada936f648a4d73b21ae6135d0933ec658468f71948b" + \
# 		"f6cfc4385da512df43f6cc1f186de8a4b1c5785a7d101f16f7c4d860a93774b7" + \
# 		"2aa2bb197707b0425a171f1943ebbc4618df62bb77d4777a354f9606dcd7197c" + \
# 		"cd06500d098c04092523ffa8a8fc9d1a688789f4bc4d450c77aed5ac9c891a81" + \
# 		"b747c12428a57d351f33fd6bbab7b200a5d2ed0045440589953297ef984232eb" + \
# 		"73fea605ef39bb13fa6db61413af05c942070ba6c8071b236130cac7f9b92899" + \
# 		"cb2ab0bd8be718231a27d013cb2c848ba6d46dc71e8796dd023cdf980b876007" + \
# 		"cbbe70f34ace4d8f902fb818e577c6909a7ef68ab77de89b8e303f8c48c71cbe" + \
# 		"23583236ca1f3590c55237611a3a7158882ce58b1ee07bd2bb7080ce0b2e3f37" + \
# 		"e57050d81e874843cfb5b265033d2e49a491e9b5a9544d13be5b0b0fb420f51f" + \
# 		"09ece44c02cbfa63c16ef5951ee8882ec756a5f82237c346e8430fddc3e209f6" + \
# 		"0db615e89071744bb217a235b9aae198403fde35c62462af4112e00990f23cd9" + \
# 		"07738588ef22949eaca1d259d66012950adbd2eebeaa140fa10a6ab3a9fa6ca1" + \
# 		"ad2149db0969c360723010cbfc1ab3f19334ac0c71be8265b3546b98248d611e" + \
# 		"be6917c5638b9f1855ab00e9ba906faed11d9492cc7366ddfbb9e1d1c27ee06d" + \
# 		"2eb8f6327deddeeb12b464fc8d448c1b794bf5bc32a0d42af1cab28f0cb85e52" + \
# 		"4c3cd3550b42d7c657fe242f4eb4c0be64e364e36cf924a0e94a83c7181e7fc3" + \
# 		"fc33f7bf7565b7a82c3e36409384fbdfb93419525038087f9ac43284494cee31" + \
# 		"0085f46dc59f013a0d6a15ed3ea986d958653926e0f41f04664b16ed3a1f2558" + \
# 		"dbfbb086e9de25801d76e1abc5af391b56bef2b27cc087e24e9c3476814cbf21" + \
# 		"e5c51e7dd33bfcee98a814cc44aa91a2ca3b7ac390e0b420b82b796aebb4c42c" + \
# 		"f749cd6eec744d6c736d64ccf5df2587ca2ad052bcf2bcfb82ca481672b22cb6" + \
# 		"5c500b9b2b90d7627c01004bc6072cf4b974a86f7bd9958aeddbbc4441ab8bb6" + \
# 		"69c4f7332a90ec182303227edd23f9126015624b1e048ddb8ad2b8e33bee32b1" + \
# 		"cd2bc0e4ee45e1b6b6aa916864ba843be59d755a0a38b401aa1370f88295889f" + \
# 		"16548f38cc71d1901f444113b9f1235f4abf2156d25507ea0f15f35fb12a8f45" + \
# 		"ca381039dd29c9190ad9d535a7c137103101f32b25cd537cbd82852bc22e79b9" + \
# 		"b80c44dd3587360e2dc17a9b20a0bb7068ccf0639c53606c99eb951fd9eb4b87" + \
# 		"ff29053ef7e1509d17976dd2677ef6e7f2d79c9800e5ef13f7963bae0fa8023a" + \
# 		"b575eb04c713f5f065d329967cdc419c5e4fcf46130b4387f093ac86de4c15f0" + \
# 		"52339d074b0391ba83e40f5b7b8198640ab30e7c0eac297f09b3459c2390e033" + \
# 		"4d0978b3badef0bfc4424e3d851a0db8b418bff74e9a752a14b5090732458c3b" + \
# 		"709071effd9f348c04ed618407cb19c934252ea264ae250a23eee2cef719a1c2" + \
# 		"11ec5f9a078f77a6b04d4efd43a9033a4a08acbc8beca97e61d1e4aaab7cc11c" + \
# 		"11f94bd0b19284d5abd7416e0d5acd7ea47357367922d803187735c42b729efb" + \
# 		"6b001ffcaa3c7d892db508ef6d85b2a0d491cf783f8b69fc4a63624278320bdd" + \
# 		"572d89f502b0f155fcc4fd52b78e41c97f05e5c5acd5d3b006740373033601dc" + \
# 		"ba2af4d0cf4ee75da988a1501e37e1d1c57fa011abdfc820dbc8ba4b2449b6f7" + \
# 		"05e92a3b35b63213f0881b289feaa5210e0d9519dcb199e76e996bcc36aaa090" + \
# 		"3210df6a824da06823ccb01f9495f79d78fd143e57832e20ad1d76e149732286" + \
# 		"53e5147df135ae34e8216740525d18d718f3dd8983e362c4f3305932c5207c29" + \
# 		"72155ae2fe9cb70b95798b50df641341bf19f8da8fa1acec43a3a42e96a2958d" + \
# 		"6bc48115c18ac202f22db64dbd3d39fab6451575a4b15ed8ad6ca72f08742cf9" + \
# 		"334706cd8ee3a0011c9c1ab1242529556df70942537fd27ab4458dc61bb15642" + \
# 		"e3b0c44298fc1c149afbf4c8996fb92427ae41e4649b934ca495991b7852b855" + \
# 		"eea15775e2b71e62ee7262c3fe774bd03846799e6778a442768aad4998960143" + \
# 		"1aca91d3b1ef4acf7521c4d3391de7a3177b17d24011987386d212f4c55c5f9a" + \
# 		"b40739dcf496499f16ee286793b5b23eedd3a969cbde0e8f4b62661c265cacf6" + \
# 		"8296c38f045fa99a30c0afb6b19f1427480b1e564b0a29d03c327c8cc1341be2" + \
# 		"2de9271f9380cd9d362ee772fb9fb9e0d4a9897c2e2c07cdbefe22fbca4844b0" + \
# 		"201179e3ffb0c33fab67f9188002981ab8fd97cd917cd46cf41bab25f0785544" + \
# 		"73c561489bfc233d4286e2f5c483b89e53abf113367b9f4a89ae5b1effbf77a3" + \
# 		"73c561489bfc233d4286e2f5c483b89e53abf113367b9f4a89ae5b1effbf77a3" + \
# 		"b033779d9a52333467e34a750c99384ab26b8dd78419c8de66f16abeb716e780" + \
# 		"50512865dc8822f2c935b9aea96cec90a857119d947908648f67ea3093f89ae3" + \
# 		"2e4888a76a3268894ffb91c8b88d555ecac6729855a9af72ef98bfea325d96bf" + \
# 		"cc0712d3f376529d92a4c2898778e1c60181e78080dbdb0f2d18f8573a50fa39" + \
# 		"a39b9a4d21d3a9c29c0d1f8ba407b97a43ddb3470c6a2a6a0f69d2bef0b3fc75" + \
# 		"cd96329fda6396e5e69f2770e8882153ad9a9e0984faa68f1d3c8d62d6e302fd" + \
# 		"3f7a0c2b6ffa86ad91c03f36a38177a6b4a3f75600d6e258820f651850304845" + \
# 		"1c79f7219b4325c1331288ea4063dad85849ece7e92d24b5a5dab0a032c3b6ce" + \
# 		"399603ba9475118f6be169fdcc23059288903d2b19f9052e969706323df04b84" + \
# 		"8f525e6dc4f91ca9d66d7228f760574637688f68c2f0097b53407bbf43156da6" + \
# 		"bd7842ca8489452605dad1a57fe20f2950d3898994e48080efcfe55e86450bb8" + \
# 		"23066a5d0d30227d208426f4ecef1298d97a1e88c8ae6765c842bc93f7845c46" + \
# 		"b6fdf0a15be7b1f03a1d7156e11df16deec7f12b1dcc92841a0dde7612c16fc5" + \
# 		"ff8c2e00e12f34aa44600a2ff81b9044e9d1cb92bfc1f7a63836ed47ecdae564" + \
# 		"668f34364314b5a07572da47de52d0e8ae0324edce67b53a9c2b98010f80a262" + \
# 		"b9e66488b06f53db3de1bfe60e68d287e6086e8102a7005e9c630b8be7fa9edd" + \
# 		"77f7cf203da12a532cddfc2b4e69d9009eb10675a12ab8f3041ee799be012fad" + \
# 		"d6fd342df0345d1e15de56abfd0793b622342b7a91ea12b5374686e622ae68e3" + \
# 		"5722fe6f39a28caee958e29bd21fcba816cd03ae6b26b2b977464cfb86ca23bf" + \
# 		"56ba10611c3a4b3ca4fc2844e10cba508d39ee2b7071c0c2b523ebc6b8b3fb79" + \
# 		"45f5cf3124cbe9c01cffb1d7cd73c36b155cbef322853faa91d0326556f2a56c" + \
# 		"704d914c57e1c6308b4bb94765f9c1fdb0fb7736d1a1af2c2c500f251f0af6cf" + \
# 		"c2795b18cd9423d7f97eefd2f5a64286f02a0253b8184dd62c09c66597570541" + \
# 		"2d709a0ea29b02a26acbd9bc705a354b6f7511ea2207713a4bcc07c34721d309" + \
# 		"123e1ee84e01256210ad8c8942c6c607f3f389f670d3e87f302e7f3ff125b359" + \
# 		"39522555729d00c125f9c6918b42bf65537009b904e16b4c2b8c160864f74537" + \
# 		"552695d47b5ed38322c2b4b29cfba22d094a1aadbb74b556e66dffc8d0a1c55c" + \
# 		"8cbb018fcd1235b7c40b64647726244714dc3761022ec0be8b608e1ea76ad673" + \
# 		"c8c1857ffcb18dd5914d35718b6a973df915ae7a5a1394ca3ed43d5c093ee177" + \
# 		"6057b32fadd13be95b6807d18e972d3ee1165fce67689943ed1c2205c4bcbb13" + \
# 		"6b162ef167922aebf21451eda1fb7f98904764f4f17f8a08e2b8e863819cf90e" + \
# 		"480dc77aacc8f78f8cb0fa6c98df41a21a8941cf7c74e824b99f2d59849f60ec" + \
# 		"d0e2b3e50536afa8562c62def235b826ba89d3f34d50f35819bf1eeebdffd765" + \
# 		"b96ffeae09c9c3993bba972722e438aeb96e8eda65a6439ef92059efacec8ba2" + \
# 		"9a84564d1e313c3bcb5bfb2c81a31e702d22894ec1b52dd3b351c01759446d24" + \
# 		"b3997c873e75b955c1d02840dfb3ee97996605a0f07fdc0307ce536ec00433f7" + \
# 		"0648c4dade9ca55d290dc451e90da0cdce9fbe18d077f3e52760275dbe937b73" + \
# 		"1ee1e6ddbee0cf09d6fd96f6de08ef09711f85cd075f24681fc3bb50f4841117" + \
# 		"6518ccd920d4a8fbf6d6126327c7696a3a66772ec1b27b3df617eae1783ee88c" + \
# 		"bde3e073390206baf1f6b6de0131e5b59e4536413ca26bfeabd7a84928a933f4" + \
# 		"b208e9902d6f6a8098c28c85b21c5e2e29a108e5b7d0235b958ab0ef27c5216f" + \
# 		"6a48d361fba9f9478159ab654a1af3b83ab7d81dd3525b849596ed7b77b6c735" + \
# 		"b5c7a7977b424db76e3b5860538b3c4480dc357cdaa898a57a9f501278916533" + \
# 		"386ebad941a47095b1d77a5c2efa8d51499b583464c9f5a02bbbfaccd2187aad" + \
# 		"5a72cb880d9235699b63bffeef83facbc8aef391b610864e1a7f1a50cd75f3bf" + \
# 		"241853181557f690edeb4d38725d5a85ae1f2535f79afa3dd7293b86f34fff9f" + \
# 		"b258dd029b4f24b8dd53bec2de7e5ae96b7e402828c78612b3c867cec0fd3326" + \
# 		"e1324adb9aa87e830fd2febed326907fdbcfe51b5c700bfa8dde5e3165054e0e" + \
# 		"0b07f026ab8ea2bc8f6abb607b4c67bd3dda1a5a292732f20935182a8efcff42" + \
# 		"6ad014f853cf486352c4d766ac42bfece37c209cd2cc2c9ba726a4ef4e1681bb" + \
# 		"12ae74c4fc064c9100a9085a2c34beb9fa80fd7e29f50a8fe8b8dbc842867488" + \
# 		"5b512742212d40c5b271614a16bb1bc1924290e6609976330ddf658b5c796646" + \
# 		"66d7135d68ea31afd50f22f795379fb794f84b5d4bd516f910b77dff3f477786" + \
# 		"19872c52af6a794d4084d5eef1843d6e39319bc5cf90b3376e5b4dcd2a53b06d" + \
# 		"d020af9f27081e4d3797dc9fdc396ebfe1be140c36c5d8f16177711559a5dcc1" + \
# 		"b26913a5df69c5271780d066c49c3818ace6bec029f79c43c0a0ec42af705f48" + \
# 		"c15fc620008d9b38e042d3e7f916782640d32cccba5c45a4ca451ef4bd377d95" + \
# 		"48944a5ced0e7b14eb50365173765e5d59d6175ec2a02b47c052702d9bcb17c4" + \
# 		"8aac5b8a2c6f556813e90707ed0589a2912dfc0d7c3d6fe5baf2dfd46792732d" + \
# 		"753f38d5107f7945a2b9cf0ce9ac6237f741641b722f8095786034434b095091" + \
# 		"eef6caccdb38535962d4ffa7a2bed5e3a4c050ce79cddfc6a60b38e81fceb5c9" + \
# 		"2ea43ad36dd8099e2963474048b4ebd82ccdbf4a28dd07f2ed1eeed21993a65d" + \
# 		"08af4ab3526cc8749bc1a24b45cf4bc266fea1fc19b527794cfb564bf43f9132" + \
# 		"7f67aee418628a3de398ab77115cf3b115d7dd6019a6db865b5cfabe3956e3a4" + \
# 		"49aa84fc16530e348fdee576e0f325b6ca93dd478ddbb81a677ae2a686297d18" + \
# 		"1c4c726b9e7ecb9a1f7c33b7d3299e31f5559f41698d752ccac5719f12316ca0" + \
# 		"92c417c0b2e661b3124f17fb485cf85f1ab2c941611b07e43493ee0a5ab30ff9" + \
# 		"5b017b3493a5692a097c4035a664d951e68c6a862b6896c5683f44eb514afee4" + \
# 		"7264c225ddcaf0ad458aeabbdfa6406475f27750f41db94d00531f9e75217a85" + \
# 		"7b4aa121070b9a28bec50fc7ee92652cf1594687af288916b8ac63d73a9e8375" + \
# 		"4f7ed27b532888ce72b96e52952073eab2354160d1156924489054b7fa9b0b1a" + \
# 		"b9386d5d73a9fb48f7e06a46039b8f369f68935a1e4cfd4521a52374be73f5cb" + \
# 		"fe8b6f422a6852821dc6809c46cf2c9e6289e924c8a4ba1b9b33bd5ef4628509" + \
# 		"57e2e2c103cfaaac06047a394a95814fb193b7ea89ac3e58dc6ad539763ab273" + \
# 		"485bc2c2bca9c24e12746bd0a1cd0c175355df18af35791888285211cade4062" + \
# 		"f6d6848174eeeb9f0392f70e9d6ef6591432410b5302298992f5b1c0c3f95a59" + \
# 		"10753a878055d649274d1a955818952822ea7299ec633ea19ded678ba5263d84" + \
# 		"efb8097cff2974b61b8b5eb3aaefc225081b4c0e76cdb5bf234afa3636d853d2" + \
# 		"d9f9bbc2466b3f17df43d25a0db574ef9103efd6b163c4326ab71d7aaff15bc1" + \
# 		"a4d077050055acc3172324d853a24a3281d3f37552dd2496bfc5837c288f813a" + \
# 		"e5cb90aa93d17cd816e1b622482e492cbf524b93e1b3f084eafb5ecc2b20fb9d" + \
# 		"a99db8e59c120138ad8a72eecedcc24b4510d2eed3ce48213b7e32f22cc4ee6e" + \
# 		"7bd2c4761ac70f4e282dc6b5f6e9f637128d37f847d0caac96958b9c4e0bcc82" + \
# 		"3793cb8874f5e156a161239fea04ad98829d4ecf623d52d43513780837eb4807" + \
# 		"cfa801a6596206ec7476e9bc2687fcd331c514b3dd92ffc3cd7d63e749ba0b2f" + \
# 		"f9cc01a86d608d24c767b641625527bc015cf8d3020d0ed419da90ebbbd4d3ef" + \
# 		"ffdfad1824fbde8ab94c50e08040edd6a82b4095c187994954471a38c45a094a" + \
# 		"7843861c897709279e22b4932f3aed0a84cda46e4a5624a756f92c32a17ee9c1" + \
# 		"6e92aa4496422a728f3bc98e7e24e96d79a79e1ab275dad419b720aea5642482" + \
# 		"e2511a62551be372ec8db99d5582494302053388f78e26c19db1a2e3d9edbf50" + \
# 		"ae4c9e45112bc04df125139249f15c87dfbb22658241b92333e6fb7d4240d742" + \
# 		"3a30a007248ddeb6fdc5a9d04b82343e7d2ae35f7c2ece270f6d5e212530acf9" + \
# 		"143fb4fb3df1c357a768fbab619b3328a775589d6a9b93496f76dfd0187f509f" + \
# 		"6b92cf6d96c657f190915cfc096220834f9f1ac7cccad3d4e8673ccfda77dfaf" + \
# 		"79e8835dff7037efb7deff572a178558bf4e65fb59ccd00012e2c2ee0f337e5a" + \
# 		"bbeaeb2977099c6d186d93f5d3c93afcdd025d072b20c91ddf40d98506468732" + \
# 		"8d933a3af4af1a84f524192c47611a4e3d16e9d90f2472ec5a94d6b696a6abd9" + \
# 		"c7296ac6c031b63849a5766243df7cc7711646b301ce02628b18d63ba30ea19d" + \
# 		"a3e21c2c31fb3a7593039f87fd74f9cca3085098a1faa5f8fe1feee449b5e200" + \
# 		"2345d2ce1b1256ae634641f238d5f01b702573c1529845256c41ec2aca39da28" + \
# 		"2e02938b2c2f9bd30773062755e4aa85ee6c7dfab19eef0a2dd697711995d185" + \
# 		"8ebb2e0d9e7ad8e7a10db7278e15c5ed0fb1b65c7fa168a33366874bb50b3632" + \
# 		"104ffbe3dd52973939e9e6f099bf72755f39ac117d3e81ef14d5d9bcf14482c8" + \
# 		"9b1c1cdced2fc490129683197eec8d9d80218688f1743ebedc0c8313367deb90" + \
# 		"37d45331a99fdf33ce18d54839c2533297c7aea06c7bb61f0c26cb825ace1de7" + \
# 		"c6a366c188507e232b5ff5f6d233b5f2722ea661e9b5c90eb67d1ce3fcf612d1" + \
# 		"029c5823c42cceeda9e543c4419a819484e0c5cca6596d53a44c9961a59d54ba" + \
# 		"dfa845d6a9a46b00ebacc68702ac81e08ee2ae1a066caca6fcda754f2fb93f8c" + \
# 		"87ad0a1cc1eb72ca0bbe1c47c248b7b4ad7ddf193c1fa2f41a780f8d8ece84f7" + \
# 		"13bd386b694360d646f08bc9ca76602ada556cacf75758736064820287eeda61" + \
# 		"06492cf8828e29be0c056b90ee14f1eeb112fedb9b2617a2e2c05ba2ef93eda6" + \
# 		"19d7081ae86325c6f120bf1ba4d324a3fcb63fd7ace14b6585045b76e6aafa67" + \
# 		"bce4c26c0d97b658ee366b65618d1d9554488f1fc232ac7b29fc76f118efcd15" + \
# 		"6c2814f66fae1ba0489c5702441cbbea176c39f460f84382e7b3acc5cb99ae32" + \
# 		"7fe8bea47ad39634d3671957768f160b821d94e1a9b372e29726504d47b7def5" + \
# 		"6dabbaa6025e96e8b30f8677d2390d8241f9afd522277eab51e73733fdb748ef" + \
# 		"23b9d84f8225766d70cd44f2bb9b559ea61de373d254865b18593d32b7425a23" + \
# 		"22f51f238f307f4eb76dfc1ae83a1f924d53d1b716ab0348336956d76c2577ab" + \
# 		"95827cd56c9c979b2840fcd00b3a7f007b421a6c5b56f5ec97aff63f6cf83cc0" + \
# 		"a1f1cd8e311c211a8b002b8ab06e1c6ddcd2320aae0759c822f81d2b268ecf35" + \
# 		"9f5bbcde6d7d798ff723dbd23654d9f4f9c6b4238cb784661c34a79700c9ed3b" + \
# 		"a8bf837216a523abd933fe2884aacc0d7e6152545fae6c0499acdf5513c359ec" + \
# 		"564a59121cc51968cbee57bdb3bdc4b4da4a695173cd11ae142922d569211f01" + \
# 		"71d3abf21920c945e980d71848416c9bfa1c5634046c05650bae06d5af2dc812" + \
# 		"19c501936667879c0465b799be95c9292e367fe968fcc87e420a81795c270a4c" + \
# 		"272b9078886a129b94443afe4caf738386b2374e335e68086390cc47c2f5b02f" + \
# 		"319bf6bb74bae666d46e6ed38276997c24eaaeac7b92d2ea10e0a53e751f311f" + \
# 		"abc44de325258b182c88a6618dc602ded1de6a3f63d7b0fafa1d89500c8cef7a" + \
# 		"5e5fe5ad93e700d6c223b4272958935137493cd3918b6a530fe515b5e4041ed5" + \
# 		"1fb304bc1c02910483e5348d94df4a5a32cb2179349c39f2cb507a26b5e6f983" + \
# 		"e54f3c19f1fd187587affa78955180c5e539bf4fb108145f14731d5734eb3c15" + \
# 		"61d7abc451f6bbeb317af6010682906fa5cf94fe559ff35b2438e3545623ca9c" + \
# 		"e31b61fba89a7d0a7aeea55631884879d75a0a4c45a327dd7dab29985aa25873" + \
# 		"c8a1e9b18fe09dc9718c24d55e29e553d828b28a73c36ae1aa24fd4dd6002c37" + \
# 		"aa713220a26092c10bcfe9dfaf49a955813e3890a20e1e22a40a7741c7fb5e4d" + \
# 		"1b669cc35bd0a2f4fd0bc557c52945d3f2db6f28c243b3763e9e29b347dfb5c6" + \
# 		"b9d06eebac81546ae2cffa5111325b0e075a0bc6216eebc2814becb3c7672ff3" + \
# 		"4423c4ce65ec801bb4bfc4fa259aaa531649ce1546c6261e632fe9b7e2771445" + \
# 		"8772b48bdd219bfbbb6eb262ba32419856e9cb4a4d8deda88cc55c28dc6124ce" + \
# 		"c4da21ddf8877726995caf5d1e175a7090ab0997be22fdc233fe180c947b1bc6" + \
# 		"201179e3ffb0c33fab67f9188002981ab8fd97cd917cd46cf41bab25f0785544" + \
# 		"38b4c9073ec5fcbcdc03b015b977acaeeaaf5d86baca34ff40b7b6401a1f43f9" + \
# 		"85749a2934d2be1005103bf52ace530fc6f0f53a73236a2c09cf27ca619e9de3" + \
# 		"44735003b0e6618f2df7ac716037fae3ca1423381396fa34e3731ebe0a7fa32b" + \
# 		"ef9e5ff3ab83e106154334ede12db5864e54817a60c4582f189939792308f360" + \
# 		"c082e6d656d277f48bb65ecc89067531559ecf5340cbe1a0ae0edfb70ab4faf9" + \
# 		"5f86985d139fe1e9e3cac428e4fd5f202d3b82739a172c9cc36eb47de0ba4523" + \
# 		"82cc6045c4a8bfe1cf02b3592aaea0d9d86cca67e056ae841f93e19e4e028c80" + \
# 		"70d314333836825e9badf1a40e38646479ad6c6fe21c88d8c2d8c8bfb861e2ff" + \
# 		"252af75d305a35c8bc5749992822b90f59fc1a9ba12803b7951ebf1f334e7dca" + \
# 		"4bccfabb7f7c6620daf8a5c092b2cf3357a0cd142f3052cc916e4f4ba5d6ff90" + \
# 		"551eb22f9a553e1e8d59f570cf87318308bf5d33ee19b9615a6ccc0a6dc28aaf" + \
# 		"fa65fa65ac7edf875f72c6bbccfa5b0c06354f801fb8d23a14ccd92d34b944d8" + \
# 		"59c4b164682321df5b7f27ec43e374e22d5e508d219b34226b8c44ba7bdf3379" + \
# 		"095175638c019ac7c0604f4c291724a16ff1acd062e181b01293bf4dcbc62cf3" + \
# 		"840f5ff309d880f974a70f1ef8cb1c80185d999a0e5793daa51f206a891f9735" + \
# 		"5d1c343229836b48cec558628d6e0b5944b2b84c546d57137b149c01988e0fd9" + \
# 		"59d9a5cdbcbb5fb64a97aa67b5ab98e695a9ab8508d10f9c073d1d371d984cdf" + \
# 		"a033e1aa6d4f5e92b6eb80655431bde038f9fab9d9269afd68a99b5359ac2b08" + \
# 		"abc1f2dcd59dfad8ba2fd9384f0f47ed408aad980d29178f2a65d59f53cfd967" + \
# 		"ea406a61b2682e97226c29d07a9629678c688908e7faaa1287b02ffb3613e30d" + \
# 		"7e750e1d1c1b1e6931d904cba9ef7f33df0e365a2bac4a1e6816cc40084fbe68" + \
# 		"cc8f48fa29aa98d5aede210f70d398907ada6d95b3027b807d30b8a43573c4ec" + \
# 		"e2c0704870d95a22ef84dbae2c7f6f03903ca89f5110e27f90db95dfd47bd0bc" + \
# 		"3369807eb93f632609209037cf9406aca743a1abe24684599701b8fb804f6ab1" + \
# 		"65c33342ce862eaa866183a86dcad5d36c46af534d0a150b789c2088ae015094" + \
# 		"1d9b79697ad9fdc7d4717f7c28b73430ca042214f30d3a0d42dce81a7c6a4f0b" + \
# 		"11960607a0b41846cbbf4e574b1b4fe3f36f038dc9c37cbcd28b7555cf532318" + \
# 		"48588ce6a514ff577a6e86cca4a75196ac4b46a25920d5c9e9a5a0e31e7399e7" + \
# 		"a323bd6ec6a7e212efcc8e10bc3e1473bdf055b046242d6bd58b1797f80f4812" + \
# 		"c8465b1fd36a8a00ad8d5b5a6efffd79e2c4870b4baf26a33a280adb5d7b16dc" + \
# 		"d8c47963d6e7a9fdffc458c221cc932bd1fea86a7f27249f2715a3e2f6fc1bf3" + \
# 		"fde0228271e80110669fabeb8d865cad76ae50e5045238de11d28f0babb0a7dc"
# 
# print "running"
# randclass = random()
# bypasstoken = bypass_token("tokens.txt",randclass.get_random)
# keyid = '72cb57e99548c111a5d6af8db9f720503d997215'
# is_new,tokenstr = bypasstoken.get_outgoing_token(keyid)
# token,create_time,expire_time = tokenstr.split(',')
# print "new token",is_new,tokenstr
# 
# bypasstoken.add_incoming_or_replicated_token(keyid,token,create_time,expire_time)
# 
# bphash = bypasstoken.generate_bypass_hash(keyid,'my test hash data')
# print "got bphash",bphash
# 
# print 'verify',bypasstoken.verify_bypass_hash(bphash,'my test hash data')
# print "earliest",bypasstoken.get_earliest_time()
	

# EOF
